USE [COWS]
GO
/****** Object:  StoredProcedure [dbo].[insertNRMData]    Script Date: 08/28/2020 10:53:36 AM ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
-- =========================================================
-- Author:		csb9923
-- Create date: 07/14/2011
-- Description:	Inserts the NRM data to NRM Tables.
-- =========================================================
ALTER PROCEDURE [dbo].[insertNRMData]
AS
BEGIN
SET NOCOUNT ON;
Begin Try
	
	OPEN SYMMETRIC KEY FS@K3y   
	DECRYPTION BY CERTIFICATE S3cFS@CustInf0;   
	
	IF OBJECT_ID(N'tempdb..#TMPSRV_INSTC',N'U') IS NOT NULL 
		DROP TABLE #TMPSRV_INSTC
	
    IF OBJECT_ID(N'tempdb..#TMPCKT',N'U') IS NOT NULL 
		DROP TABLE #TMPCKT 
	
	IF OBJECT_ID(N'tempdb..#TMPVNDR',N'U') IS NOT NULL 
		DROP TABLE #TMPVNDR

	IF OBJECT_ID(N'tempdb..#FTNTable',N'U') IS NOT NULL 
		DROP TABLE #FTNTable
	
	CREATE TABLE #TMPSRV_INSTC(
	SRVC_INSTC_OBJ_ID BIGINT,
	SRVC_INSTC_NME VARCHAR(200),
	LOOP_ACPT_DT DATETIME,
	ORDR_STUS_DES VARCHAR(200),
	DSCNCT_DT DATETIME,
	ACTV_DT DATETIME,
	ORDR_CMNT_TXT VARCHAR(5000),
	MDS_CD BIT,
	H5_H6_ID VARCHAR(200),
	FTN varchar(20),
	NUA_ADR VARCHAR(200),
	BILL_CLEAR_DT DATETIME,
	Flag INT default 0
	)
	
	
	CREATE TABLE #TMPCKT(
	SRVC_INSTC_OBJ_ID BIGINT,
	SRVC_INSTC_NME VARCHAR(200),
	FTN VARCHAR(20) DEFAULT '',
	CKT_OBJ_ID VARCHAR(200),
	CKT_NME VARCHAR(200),
	FMS_CKT_ID VARCHAR(200),
	NUA_ADR VARCHAR(200),
	PLN_NME VARCHAR(200),
	PLN_SEQ_NBR VARCHAR(200),
	TOC_ADR VARCHAR(1500),
	PORT_ASMT_DES VARCHAR(200),
	TOC_NME VARCHAR(200),
	FMS_SITE_ID VARCHAR(200),
	TOC_ADR_1 VARCHAR(1500),
	TOC_ADR_2 VARCHAR(1500),
	TOC_CTY_NME VARCHAR(200),
	TOC_DMSTC_STT_NME VARCHAR(200),
	TOC_ZIP_CD VARCHAR(200),
	TOC_CTRY_CD VARCHAR(200),
	TOC_CTRY_NME VARCHAR(200),
	Flag INT DEFAULT 0
	)
	
	
	CREATE TABLE #TMPVNDR(
	SRVC_INSTC_OBJ_ID BIGINT,
	FTN varchar(20),
	VNDR_NME VARCHAR(200),
	VNDR_TYPE_ID VARCHAR(200),
	LEC_ID VARCHAR(200),
	VNDR_CKT_ID VARCHAR(200),
	SEG_TYPE_ID VARCHAR(200),
	H6_H5_ID VARCHAR(200),
	Flag INT DEFAULT 0
	)
	
		--Get the Filtered FTNs
		DECLARE @FTNS NVARCHAR(MAX)
		DECLARE @CMD1 AS NVARCHAR(MAX)
	
		CREATE TABLE #FTNTable
		(
			ID		INT IDENTITY(1,1),
			FTN		varchar(20),
			Sts		TINYINT	--0 not picked up.  1 - to be picked up.  2 - Already picked up.  3 - Ready for second query.  4 - Finished second query
		)

		INSERT INTO #FTNTable (FTN, Sts)
		SELECT DISTINCT FTN, 0
		FROM	dbo.ORDR ord WITH (NOLOCK)
			INNER JOIN	dbo.LK_PPRT lkp WITH (NOLOCK) ON ord.PPRT_ID=lkp.PPRT_ID
			INNER JOIN	dbo.FSA_ORDR fs WITH (NOLOCK) ON ord.ORDR_ID=fs.ORDR_ID
		WHERE	lkp.TRPT_CD	=	1
			AND	fs.ORDR_ACTN_ID	=	2
			AND ord.ORDR_STUS_ID NOT IN (4,5)   -- dlp0278 added Sept 2020 release.
			AND ord.CREAT_DT > DATEADD(MM,-18,GETDATE()) -- dlp0278 added Sept release.
			AND	NOT EXISTS -- There could be multiple entries for same FTN in NRM table so had to use NOT EXISTS
				(
					SELECT		'X'
						FROM	dbo.NRM_SRVC_INSTC	ns WITH (NOLOCK)
						WHERE	ns.FTN						=	fs.FTN
							AND	ISNULL(ns.BILL_CLEAR_DT,'')	<>	'' 
				)

		CREATE CLUSTERED INDEX IDX_C_FTNTable ON #FTNTable(ID)
		CREATE INDEX IDX_FTN_FTNTable ON #FTNTable(FTN)

		WHILE EXISTS (SELECT 1	FROM #FTNTable	f	WHERE	Sts = 0)
		BEGIN
			SET		@FTNS	=	NULL
	
			UPDATE TOP (400) f
			SET		Sts	=	1
			FROM	#FTNTable f
			WHERE	Sts	=	0

			SELECT	@FTNS = COALESCE(@FTNS+''''',''''' ,'') + convert(varchar,f.FTN)
			FROM	#FTNTable	f	
			WHERE	Sts	=	1

			SET @CMD1 = 'INSERT INTO #TMPSRV_INSTC ' +
			'SELECT SI_OBJ_ID,SI_NME,LOOP_ACPT_DTE,ORDER_STUS,DISCNT_DTE,ACTV_DTE,ORDER_CMNTS,CASE MDS_FLG WHEN ''No'' THEN 0 ELSE 1 END AS MDS_FLG,H5_H6_ID,FTN,NUA,BILL_CLEAR_DATE,0 ' +
			'FROM OPENQUERY ' +
			'(NRM, ' +
			'''SELECT SI_OBJ_ID,SI_NME,LOOP_ACPT_DTE,ORDER_STUS,DISCNT_DTE,ACTV_DTE,ORDER_CMNTS,MDS_FLG,H5_H6_ID,FTN,NUA,BILL_CLEAR_DATE,0' +
			' FROM rdbadm.NRM_SRVC_INSTC_SHRPNT_MV ' +
			'WHERE ' +
			'FTN IN (''''' + @FTNS + ''''')''' + ')'
			
			UPDATE	f
			SET		Sts	=	2
			FROM	#FTNTable	f
			WHERE	Sts	=	1
	
	
			EXEC sp_executesql @CMD1
		END	
		----Get the Filtered FTNs
		--DECLARE @FTNS NVARCHAR(MAX)
		
		--	SELECT TOP 450 @FTNS = COALESCE(@FTNS+''''',''''' ,'') + convert(varchar,fs.FTN)
		--	FROM	dbo.ORDR ord WITH (NOLOCK)
		--INNER JOIN	dbo.LK_PPRT lkp WITH (NOLOCK) ON ord.PPRT_ID=lkp.PPRT_ID
		--INNER JOIN	dbo.FSA_ORDR fs WITH (NOLOCK) ON ord.ORDR_ID=fs.ORDR_ID
		--	WHERE	lkp.TRPT_CD	=	1
		--	AND		fs.ORDR_ACTN_ID	=	2
		--	AND		NOT EXISTS -- There could be multiple entries for same FTN in NRM table so had to use NOT EXISTS
		--			(
		--				SELECT		'X'
		--					FROM	dbo.NRM_SRVC_INSTC	ns WITH (NOLOCK)
		--					WHERE	ns.FTN						=	fs.FTN
		--						AND	ISNULL(ns.BILL_CLEAR_DT,'')	<>	'' 
		--			)
	
		
		----NRM_SRVC_INSTC 
		--DECLARE @CMD1 AS NVARCHAR(MAX)

		--SET @CMD1 = 'INSERT INTO #TMPSRV_INSTC ' +
		--'SELECT SI_OBJ_ID,SI_NME,LOOP_ACPT_DTE,ORDER_STUS,DISCNT_DTE,ACTV_DTE,ORDER_CMNTS,CASE MDS_FLG WHEN ''No'' THEN 0 ELSE 1 END AS MDS_FLG,H5_H6_ID,FTN,NUA,BILL_CLEAR_DATE,0 ' +
		--'FROM OPENQUERY ' +
		--'(NRM, ' +
		--'''SELECT SI_OBJ_ID,SI_NME,LOOP_ACPT_DTE,ORDER_STUS,DISCNT_DTE,ACTV_DTE,ORDER_CMNTS,MDS_FLG,H5_H6_ID,FTN,NUA,BILL_CLEAR_DATE,0' +
		--' FROM rdbadm.NRM_SRVC_INSTC_SHRPNT_MV ' +
		--'WHERE ' +
		--'FTN IN (''''' + @FTNS + ''''')''' + ')'
		
		----PRINT @CMD1
		--EXEC sp_executesql @CMD1

	
	
		UPDATE #TMPSRV_INSTC WITH (ROWLOCK)
			SET Flag=1 
				WHERE EXISTS(
								SELECT 'x' 
									FROM	dbo.NRM_SRVC_INSTC WITH (NOLOCK) 
									WHERE	SRVC_INSTC_OBJ_ID	=	#TMPSRV_INSTC.SRVC_INSTC_OBJ_ID
										AND	FTN					=	#TMPSRV_INSTC.FTN
										AND	ISNULL(NUA_ADR,'')	=	ISNULL(#TMPSRV_INSTC.NUA_ADR,'')
							)
				
		--Insert the new records
		INSERT INTO COWS.dbo.NRM_SRVC_INSTC(SRVC_INSTC_OBJ_ID,SRVC_INSTC_NME,LOOP_ACPT_DT,ORDR_STUS_DES,DSCNCT_DT,ACTV_DT,ORDR_CMNT_TXT,MDS_CD,H5_H6_ID,FTN,NUA_ADR,BILL_CLEAR_DT,CREAT_DT,MODFD_DT,REC_STUS_ID)
			SELECT SRVC_INSTC_OBJ_ID,SRVC_INSTC_NME,LOOP_ACPT_DT,ORDR_STUS_DES,DSCNCT_DT,ACTV_DT,
					SUBSTRING(ORDR_CMNT_TXT,1,1000),MDS_CD,H5_H6_ID,FTN,NUA_ADR,BILL_CLEAR_DT,GETDATE(),GETDATE(),1
				FROM #TMPSRV_INSTC WITH (NOLOCK) 
				WHERE Flag=0
		--Update the existing records		
		
		UPDATE  ct
			SET  ct.LOOP_ACPT_DT=tt.LOOP_ACPT_DT,
			ct.ORDR_STUS_DES=tt.ORDR_STUS_DES,
			ct.DSCNCT_DT=tt.DSCNCT_DT,
			ct.ACTV_DT=tt.ACTV_DT,
			ct.ORDR_CMNT_TXT=SUBSTRING(tt.ORDR_CMNT_TXT,1,1000),
			ct.MDS_CD=tt.MDS_CD,
			ct.H5_H6_ID=tt.H5_H6_ID,
			ct.NUA_ADR=tt.NUA_ADR,
			ct.BILL_CLEAR_DT=tt.BILL_CLEAR_DT,
			ct.MODFD_DT=GETDATE()
			FROM	COWS.dbo.NRM_SRVC_INSTC ct WITH (ROWLOCK)
		INNER JOIN	#TMPSRV_INSTC tt WITH (NOLOCK)	ON	ct.SRVC_INSTC_OBJ_ID	=	tt.SRVC_INSTC_OBJ_ID
													AND	ct.FTN					=	tt.FTN
													AND	ISNULL(ct.NUA_ADR,'')	=	ISNULL(tt.NUA_ADR,'')
			WHERE tt.Flag=1
			

		--NRM_CKT
		DECLARE @CMD2 AS NVARCHAR(MAX)

		WHILE EXISTS (SELECT 1	FROM #FTNTable	f	WHERE	Sts=2)
		BEGIN
			SET		@FTNS	=	NULL
	
			UPDATE TOP (400) f
			SET		Sts	=	3
			FROM	#FTNTable f
			WHERE	Sts	=	2

			SELECT	@FTNS = COALESCE(@FTNS+''''',''''' ,'') + convert(varchar,f.FTN)
			FROM	#FTNTable	f	
			WHERE	Sts	=	3

			SET @CMD2 = 'INSERT INTO #TMPCKT ' +
			'SELECT * ' +
			'FROM OPENQUERY ' +
			'(NRM, ' +
			'''SELECT SI_OBJ_ID,SI_NME,1,CKT_OBJ_ID,CKT_NME,FMS_CKT_ID,NUA,PLN,PLN_SEQ,TOC_ADDR,PORT_ASSGN,TOC_NME,FMS_SITE_ID,TOC_ADDRESS1,TOC_ADDRESS2,TOC_CITY,TOC_DOMESTIC_STATE,TOC_ZIP_CODE,TOC_COUNTRY_CODE,TOC_COUNTRY,0' +
			' FROM rdbadm.NRM_CKT_SHRPNT_MV ' +
			' WHERE SI_OBJ_ID IN (Select SI_OBJ_ID FROM rdbadm.NRM_SRVC_INSTC_SHRPNT_MV ' +
			' WHERE FTN IN (''''' + @FTNS + '''''))''' + ')'	
			
			UPDATE	f
			SET		Sts	=	4
			FROM	#FTNTable	f
			WHERE	Sts	=	3
	
	
			EXEC sp_executesql @CMD2
		END	

		--SET @CMD2 = 'INSERT INTO #TMPCKT ' +
		--'SELECT * ' +
		--'FROM OPENQUERY ' +
		--'(NRM, ' +
		--'''SELECT SI_OBJ_ID,SI_NME,1,CKT_OBJ_ID,CKT_NME,FMS_CKT_ID,NUA,PLN,PLN_SEQ,TOC_ADDR,PORT_ASSGN,TOC_NME,FMS_SITE_ID,TOC_ADDRESS1,TOC_ADDRESS2,TOC_CITY,TOC_DOMESTIC_STATE,TOC_ZIP_CODE,TOC_COUNTRY_CODE,TOC_COUNTRY,0' +
		--' FROM rdbadm.NRM_CKT_SHRPNT_MV ' +
		--' WHERE SI_OBJ_ID IN (Select SI_OBJ_ID FROM rdbadm.NRM_SRVC_INSTC_SHRPNT_MV ' +
		--' WHERE FTN IN (''''' + @FTNS + '''''))''' + ')'	
		
		----PRINT @CMD2
		--EXEC sp_executesql @CMD2

		DELETE nc
			FROM		dbo.NRM_CKT nc WITH (ROWLOCK)
			INNER JOIN	#TMPCKT t WITH (NOLOCK) ON	ISNULL(nc.SRVC_INSTC_OBJ_ID,0) = ISNULL(t.SRVC_INSTC_OBJ_ID,0)

			UPDATE		t
				SET		t.FTN	=	ISNULL(s.FTN,'')
				FROM	#TMPCKT				t WITH (ROWLOCK)
			LEFT JOIN	#TMPSRV_INSTC		s WITH (NOLOCK) ON s.SRVC_INSTC_OBJ_ID = t.SRVC_INSTC_OBJ_ID
				WHERE	t.Flag	= 0								
					
					
		  --Insert the new records
		  INSERT INTO COWS.dbo.NRM_CKT
						    (SRVC_INSTC_OBJ_ID,SRVC_INSTC_NME,FTN,CKT_OBJ_ID,CKT_NME,FMS_CKT_ID,NUA_ADR,PLN_NME,PLN_SEQ_NBR,PORT_ASMT_DES,TOC_NME,FMS_SITE_ID,CREAT_DT,REC_STUS_ID,MODFD_DT)
		  SELECT	DISTINCT tc.SRVC_INSTC_OBJ_ID,tc.SRVC_INSTC_NME,tc.FTN,tc.CKT_OBJ_ID,tc.CKT_NME,tc.FMS_CKT_ID,tc.NUA_ADR,tc.PLN_NME,tc.PLN_SEQ_NBR,tc.PORT_ASMT_DES,tc.TOC_NME,tc.FMS_SITE_ID,GETDATE(),1,GETDATE() 
				FROM	#TMPCKT tc WITH (NOLOCK)
				WHERE	tc.Flag = 0

		  UPDATE nc
		  SET TOC_CTY_NME = tc.TOC_CTY_NME,
			  TOC_DMSTC_STT_NME = tc.TOC_DMSTC_STT_NME,
			  TOC_ADR = tc.TOC_ADR,
			  TOC_ADR_1 = tc.TOC_ADR_1,
			  TOC_ADR_2 = tc.TOC_ADR_2,
			  TOC_ZIP_CD = tc.TOC_ZIP_CD,
			  TOC_CTRY_NME = tc.TOC_CTRY_NME,
			  TOC_CTRY_CD = tc.TOC_CTRY_CD
		  FROM dbo.NRM_CKT nc  INNER JOIN
			   #TMPCKT tc WITH (NOLOCK) ON nc.FTN=tc.FTN AND nc.SRVC_INSTC_OBJ_ID=tc.SRVC_INSTC_OBJ_ID AND nc.SRVC_INSTC_NME=tc.SRVC_INSTC_NME INNER JOIN
			   dbo.FSA_ORDR fo WITH (NOLOCK) ON fo.FTN=nc.FTN INNER JOIN
			   dbo.ORDR ordr WITH (NOLOCK) ON ordr.ORDR_ID=fo.ORDR_ID
		  WHERE ordr.CSG_LVL_ID=0
		    AND tc.Flag = 0

		 INSERT INTO dbo.[CUST_SCRD_DATA] ([SCRD_OBJ_ID], [SCRD_OBJ_TYPE_ID], [CTY_NME], [STT_PRVN_NME], [SITE_ADR], [STREET_ADR_1], [STREET_ADR_2], [ZIP_PSTL_CD],
		[CTRY_RGN_NME], [CTRY_CD])
		SELECT nrc.[NRM_CKT_ID], 29, dbo.encryptstring([TOC_CTY_NME]), dbo.encryptstring([TOC_DMSTC_STT_NME]), 
		dbo.encryptstring([TOC_ADR]), dbo.encryptstring([TOC_ADR_1]), dbo.encryptstring([TOC_ADR_2]), dbo.encryptstring([TOC_ZIP_CD]),
		dbo.encryptstring([TOC_CTRY_NME]), dbo.encryptstring([TOC_CTRY_CD])
		FROM dbo.NRM_CKT nrc WITH (NOLOCK) 
		WHERE [NRM_CKT_ID] IN
		(SELECT DISTINCT nc.[NRM_CKT_ID]
		FROM dbo.[NRM_CKT] nc WITH (NOLOCK) INNER JOIN
		#TMPCKT tc WITH (NOLOCK) ON nc.FTN=tc.FTN AND nc.SRVC_INSTC_OBJ_ID=tc.SRVC_INSTC_OBJ_ID AND nc.SRVC_INSTC_NME=tc.SRVC_INSTC_NME INNER JOIN
		dbo.[FSA_ORDR] fo WITH (NOLOCK) ON fo.FTN=nc.FTN INNER JOIN
		dbo.ORDR ordr WITH (NOLOCK) ON ordr.ORDR_ID=fo.ORDR_ID
		WHERE (ordr.CSG_LVL_ID > 0)
		AND tc.Flag = 0
		AND NOT EXISTS (SELECT 'x' FROM dbo.[CUST_SCRD_DATA] csd WITH (NOLOCK) WHERE csd.[SCRD_OBJ_ID]=nc.[NRM_CKT_ID] and csd.[SCRD_OBJ_TYPE_ID]=29))
					

	
		--NRM_VNDR
		DECLARE @CMD3 AS NVARCHAR(MAX)

		WHILE EXISTS (SELECT 1	FROM #FTNTable	f	WHERE	Sts=4)
		BEGIN
			SET		@FTNS	=	NULL
	
			UPDATE TOP (400) f
			SET		Sts	=	5
			FROM	#FTNTable f
			WHERE	Sts	=	4

			SELECT	@FTNS = COALESCE(@FTNS+''''',''''' ,'') + convert(varchar,f.FTN)
			FROM	#FTNTable	f	
			WHERE	Sts	=	5

			SET @CMD3 = 'INSERT INTO #TMPVNDR ' +
			'SELECT * ' +
			'FROM OPENQUERY ' +
			'(NRM, ' +
			'''SELECT SI_OBJ_ID,FTN,VNDR_NME,VNDR_TYP,LEC_ID,VNDR_CKT_ID,SGNMT_TYP,H6_H5_ID,0' +
			' FROM rdbadm.NRM_VNDR_INFO_SHRPNT_MV ' +
			' WHERE FTN IN (''''' + @FTNS + ''''')''' + ')'
			
			UPDATE	f
			SET		Sts	=	6
			FROM	#FTNTable	f
			WHERE	Sts	=	5
	
	
			EXEC sp_executesql @CMD3
		END	

		--SET @CMD3 = 'INSERT INTO #TMPVNDR ' +
		--'SELECT * ' +
		--'FROM OPENQUERY ' +
		--'(NRM, ' +
		--'''SELECT SI_OBJ_ID,FTN,VNDR_NME,VNDR_TYP,LEC_ID,VNDR_CKT_ID,SGNMT_TYP,H6_H5_ID,0' +
		--' FROM rdbadm.NRM_VNDR_INFO_SHRPNT_MV ' +
		--' WHERE FTN IN (''''' + @FTNS + ''''')''' + ')'
	
		----PRINT @CMD3
		--EXEC sp_executesql @CMD3
	
		--Mark the existing records
		UPDATE tvndr
		SET tvndr.Flag=1
		FROM #TMPVNDR tvndr WITH (ROWLOCK)
		WHERE EXISTS(
						SELECT 'x' 
							FROM	dbo.NRM_VNDR WITH (NOLOCK) 
							WHERE	SRVC_INSTC_OBJ_ID=tvndr.SRVC_INSTC_OBJ_ID
								AND	FTN	=	tvndr.FTN
					)
		
		
		--Insert the new records	
		INSERT INTO COWS.dbo.NRM_VNDR(SRVC_INSTC_OBJ_ID,FTN,VNDR_NME,VNDR_TYPE_ID,LEC_ID,VNDR_CKT_ID,SEG_TYPE_ID,H6_H5_ID,CREAT_DT,REC_STUS_ID,MODFD_DT)
		 SELECT SRVC_INSTC_OBJ_ID,FTN,VNDR_NME,VNDR_TYPE_ID,LEC_ID,VNDR_CKT_ID,SEG_TYPE_ID,ISNULL(H6_H5_ID,''),GETDATE(),1,GETDATE() 
				FROM #TMPVNDR WITH (NOLOCK) WHERE Flag=0
	
		--Update the existing records
		UPDATE cvdr
		SET cvdr.FTN=tmpvdr.FTN,
		cvdr.VNDR_NME=tmpvdr.VNDR_NME,
		cvdr.VNDR_TYPE_ID=tmpvdr.VNDR_TYPE_ID,
		cvdr.LEC_ID=tmpvdr.LEC_ID,
		cvdr.VNDR_CKT_ID=tmpvdr.VNDR_CKT_ID,
		cvdr.SEG_TYPE_ID=tmpvdr.SEG_TYPE_ID,
		cvdr.H6_H5_ID=ISNULL(tmpvdr.H6_H5_ID,''),
		cvdr.MODFD_DT = GETDATE()
		FROM dbo.NRM_VNDR cvdr WITH (ROWLOCK)
		INNER JOIN #TMPVNDR tmpvdr WITH (NOLOCK) ON cvdr.SRVC_INSTC_OBJ_ID=tmpvdr.SRVC_INSTC_OBJ_ID
		WHERE Flag=1
	
	DROP TABLE #TMPVNDR
	DROP TABLE #TMPCKT
	DROP TABLE #TMPSRV_INSTC
	DROP TABLE #FTNTable
	
End Try
Begin Catch
	EXEC dbo.insertErrorInfo
End Catch
END